unit AffichTabCod;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Grids, ColorStringGrid, StdCtrls, Buttons, ExtCtrls,listarray2,
  StructureDonnees,donnees;

type
  TAffTabCod = class(TForm)
    ColorStringGrid: TColorStringGrid;
    MainMenu1: TMainMenu;
    Fermer1: TMenuItem;
    Copier1: TMenuItem;
    commetexte1: TMenuItem;
    commeimage1: TMenuItem;
    PanelCode: TPanel;
    Label2: TLabel;
    CouleurTexte: TLabel;
    Panel1: TPanel;
    Label3: TLabel;
    StyleFond: TComboBox;
    ModeColor: TComboBox;
    Panel2: TPanel;
    AnnuleCouleur: TButton;
    Valider: TButton;
    CaseCoul: TCaseCoul;
    ColorDialog: TColorDialog;
    Editer1: TMenuItem;
    Mettreencouleurs1: TMenuItem;
    Modifier1: TMenuItem;
    N1: TMenuItem;
    Reveniraucodagedorigine1: TMenuItem;               
    Shape1: TShape;
    Valider1: TMenuItem;
    procedure Fermer1Click(Sender: TObject);
    procedure commetexte1Click(Sender: TObject);
    procedure StyleFondChange(Sender: TObject);
    procedure CouleurTexteClick(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Mettreencouleurs1Click(Sender: TObject);
    procedure Modifier1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ValiderClick(Sender: TObject);
    procedure ColorStringGridMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ColorStringGridGetEditMask(Sender: TObject; ACol,
      ARow: Integer; var Value: String);
    procedure ColorStringGridGetEditText(Sender: TObject; ACol,              
      ARow: Integer; var Value: String);
    procedure AnnuleCouleurClick(Sender: TObject);
  private
    { Dclarations prives }
    CoulRAZ:TAffichCoul;
    Valide:Boolean;
    function VerifieCode:Boolean;
    function VerifieCouleurs:Boolean;
    procedure ChargeLangue;
  public
    { Dclarations publiques }
    MisEnCoul:TAffichCoul;
    AInitialiser:boolean;
    MaxiNum:integer;
    AffCouls:Array of TAffichCoul;
    MesCarD:TCarDs;
    procedure ConstruitTableau;
    procedure ConstruitLeCode;
  end;

var
  AffTabCod: TAffTabCod;

implementation
uses Clipbrd,phylParenteLyc,GestionTextes;
{$R *.dfm}

procedure TAffTabCod.Fermer1Click(Sender: TObject);
begin
  Close;
end;

procedure TAffTabCod.commetexte1Click(Sender: TObject);
Var
  Tableau:TStringGrid;
  i,j:integer;
  Chaine:string;
  ChaineTableau:TStringList;
  ZeroTerminal:PChar;
  CarSautCol:string;
begin
  Tableau:=ColorStringGrid;
  ChaineTableau:=TStringList.Create;
  ChaineTableau.Clear;
  //if Titre<>'' then ChaineTableau.Add(Titre);
  for i:=0 to Tableau.RowCount - 1 do
    begin
      Chaine:=Tableau.Cells[0,i];
      for j:=1 to Tableau.ColCount - 1 do
        begin
          chaine:=chaine+CarSautCol+Tableau.Cells[j,i];
        end;
      ChaineTableau.Add(chaine);
    end;
  ZeroTerminal:=ChaineTableau.GetText;
  ClipBoard.SetTextBuf(ZeroTerminal);
  ChaineTableau.Free;
end;

procedure TAffTabCod.StyleFondChange(Sender: TObject);
Var
  nvStyle:TbrushStyle;
begin
  nvstyle:=bsSolid;
  Case StyleFond.ItemIndex of
    1:nvstyle:=bsBDiagonal;
    2:nvstyle:=bsFDiagonal;
    3:nvstyle:=bsHorizontal;
    4:nvstyle:=bsVertical;
    5:nvstyle:=bsCross;
    6:nvStyle:=bsDiagCross;
  end;
  CaseCoul.styleFond:=nvStyle;
  CaseCoul.Repaint;
  MisEnCoul.styleFond:=nvStyle;
end;

procedure TAffTabCod.CouleurTexteClick(Sender: TObject);
begin
  ColorDialog.Color:=CouleurTexte.Font.Color;
  if ColorDialog.Execute then
    begin
      CouleurTexte.Font.Color:=ColorDialog.Color;
      MisEnCoul.CouleurTexte:=ColorDialog.Color;
    end;
end;

procedure TAffTabCod.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog.Color:=MisEnCoul.CouleurFond;
  if ColorDialog.Execute then
    begin
      MisEnCoul.CouleurFond:=ColorDialog.Color;
      CouleurTexte.Color:=ColorDialog.Color;
      CaseCoul.CouleurFond:=ColorDialog.Color;
      CaseCoul.Repaint;
    end;
end;

procedure TAffTabCod.Mettreencouleurs1Click(Sender: TObject);
begin
  if VerifieCode then
    begin
      Mettreencouleurs1.Checked:=True;
      PanelCode.Visible:=True;
      ColorStringGrid.Options:=ColorStringGrid.Options-[goEditing];
    end;
end;

procedure TAffTabCod.Modifier1Click(Sender: TObject);
begin
  Modifier1.Checked:=True;
  PanelCode.Visible:=False;
  ColorStringGrid.Options:=ColorStringGrid.Options+[goEditing];
end;

procedure TAffTabCod.FormCreate(Sender: TObject);
begin
  ChargeLangue;
  MesCarD:=TCarDs.Create;
  Caption:='Tableau de codage';
  CouleurTexte.Color:=CaseCoul.CouleurFond;
  MisEnCoul.Active:=True;
  MisEnCoul.CouleurFond:=CaseCoul.CouleurFond;
  MisEnCoul.CouleurTexte:=CouleurTexte.Font.Color;
  MisEnCoul.styleFond:=CaseCoul.StyleFond;
  MisEnCoul.CouleurContour:=CaseCoul.CouleurContour;
  CoulRAZ.Active:=False;
  CoulRAZ.CouleurFond:=ClWhite;
  CoulRAZ.CouleurTexte:=clBlack;
  CoulRAZ.styleFond:=bsSolid;
  CoulRAZ.CouleurContour:=clBlack;
  AInitialiser:=True;
end;

procedure TAffTabCod.ConstruitTableau;
Var
  i,j,n,nb:integer;
  UnCarD:TCaractD;
  Aff:TAffichCoul;
  LeCode:TStrListarray;
begin
  if AInitialiser then
    begin
      MesCarD.Assign(LasousCollection.Caracteres.CarDs);
      AInitialiser:=False;
    end;
  LeCode:=MesCarD.CodesEtats;
  ColorStringGrid.Efface;
  ColorStringGrid.RowCount:=LeCode.RowCount+1;
  ColorStringGrid.ColCount:=LeCode.GetMaxColCount;
  ColorStringGrid.Cells[0,0]:='Caractres';
  ColorStringGrid.Cells[1,0]:='Type';
  for i:=1 to (ColorStringGrid.ColCount-1) div 2 do
    begin
      ColorStringGrid.Cells[2*i,0]:='tat '+IntToStr(i);
      ColorStringGrid.Cells[2*i+1,0]:='code '+IntToStr(i);
    end;
  nb:=0;
  For i:=0 to LeCode.RowCount-1 do
    begin
      Aff:=CoulRAZ;
      UnCarD:=MesCarD.GetCarD(LeCode.StrItems[i,0]);
      if FormParenteLyc.TabGrid1.Rows[0].IndexOf(UnCarD.Nom)>0 then
        begin
          inc(nb);
          For j:=0 to LeCode.ColCount[i]-1 do
            begin
              ColorStringGrid.Cells[j,nb]:=LeCode.StrItems[i,j];
              if (j>1)and((j mod 2)=0) and (UnCarD<>Nil) then
                begin
                  n:=UnCarD.ListeEtats.IndexOf(LeCode.StrItems[i,j]);
                  if (n>-1) and (Length(UnCarD.CouleursEtats)>n) then
                    Aff:=ConvertitAffCelAffCoul(UnCarD.CouleursEtats[n])
                  else Aff:=CoulRAZ;
                end;
              ColorStringGrid.AffichCell[j,nb]:=Aff;
            end;
        end;
    end;
  ColorStringGrid.RowCount:=nb+1;
  MaxiNum:=(LeCode.GetMaxColCount-2)div 2;
  SetLength(AffCouls,MaxiNum);
  ColorStringGrid.ajusteColonnes;
end;
procedure TAffTabCod.ConstruitLeCode;
Var
  i,j,n:integer;
  UnCarD:TCaractD;
  //LeCode:TStrListArray;
begin
 { LeCode:=TStrListArray.CreateListArray;
  For i:=0 to ColorStringGrid.RowCount-1 do
    For j:=0 to ColorStringGrid.ColCount-1 do
      begin
        if ColorStringGrid.Cells[j,i+1]<>'' then
          LeCode.StrItems[i,j]:=ColorStringGrid.Cells[j,i+1];
      end;
  LeCode.Free;}
  //Ajustement de l'ordre des tats de caractre
  for j:=1 to ColorStringGrid.RowCount-1 do
    begin
      UnCarD:=MesCarD.GetCarD(ColorStringGrid.Cells[0,j]);
      if UnCarD<>Nil then
        begin
          for i:=0 to MaxiNum-1 do
            begin
              if ColorStringGrid.Cells[i*2+2,j]<>'' then
                begin
                  n:=UnCarD.ListeEtats.IndexOf(ColorStringGrid.Cells[i*2+2,j]);
                  SetLength(UnCarD.CouleursEtats,UnCarD.ListeEtats.Count);
                  if n>-1 then
                    begin
                      UnCarD.ListeEtats.Move(n,i);
                      UnCarD.CouleursEtats[i]:=ConvertitAffCoulAffCel(ColorStringGrid.AffichCell[i*2+2,j]);
                    end;
                end
              else break;
            end;
        end;
    end;
  MesCarD.CreeCodeSEtats;
end;
procedure TAffTabCod.ValiderClick(Sender: TObject);
begin
  //tester puis modifier LeCode
  if VerifieCode then
    begin
      if VerifieCouleurs then
        begin
          // Modifier LeCode
          ConstruitLeCode;
          Valide:=True;
//          MessageDlg('Le codage semble cohrent',mtInformation,[mbOK],0);
          MessageDlg(M_Lecodagesemblecohr,mtInformation,[mbOK],0);
        end;
    end;
end;

procedure TAffTabCod.ColorStringGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  Col,Ligne,i,j,n:integer;
begin
  ColorStringGrid.MouseToCell(X,Y,col,Ligne);
  ColorStringGrid.Cells[Col,Ligne]:=Trim(ColorStringGrid.Cells[Col,Ligne]);
  if Mettreencouleurs1.Checked then
    begin
      if (Col>1)and (Ligne>0) and (ColorStringGrid.Cells[Col,Ligne]<>'')then
        begin
          ColorStringGrid.AffichCell[Col,Ligne]:=MisEnCoul;
          if (Col mod 2)=0 then ColorStringGrid.AffichCell[Col+1,Ligne]:=MisEnCoul
          else ColorStringGrid.AffichCell[Col-1,Ligne]:=MisEnCoul;
          if ModeColor.ItemIndex=1 then
            begin
              try
                if (Col mod 2)=0 then
                  begin
                    ColorStringGrid.Cells[Col+1,Ligne]:=Trim(ColorStringGrid.Cells[Col+1,Ligne]);
                    n:=StrToInt(ColorStringGrid.Cells[Col+1,Ligne]);
                  end
                else
                  n:=StrToInt(ColorStringGrid.Cells[Col,Ligne]);
                AffCouls[n]:=MisEnCoul;
                for j:=1 to ColorStringGrid.RowCount-1 do
                  for i:=0 to MaxiNum-1 do
                    if ColorStringGrid.Cells[i*2+3,j]=IntToStr(n) then
                      begin
                        ColorStringGrid.AffichCell[i*2+2,j]:=MisEnCoul;
                        ColorStringGrid.AffichCell[i*2+3,j]:=MisEnCoul;
                      end;
                ColorStringGrid.Refresh;
              except
              end;
            end;
        end;
    end
  else
    begin
      if (Col mod 2)=0 then
        ColorStringGrid.Options:=ColorStringGrid.Options-[goEditing]
      else if trim(ColorStringGrid.Cells[Col-1,Ligne])='' then
        ColorStringGrid.Options:=ColorStringGrid.Options-[goEditing]
      else
        ColorStringGrid.Options:=ColorStringGrid.Options+[goEditing];
    end;
end;

procedure TAffTabCod.ColorStringGridGetEditMask(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
  if ACol=1 then
    Value:='0'
  else
    Value:='#0';
end;

procedure TAffTabCod.ColorStringGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
Var
  AncStr:string;
  n:integer;
begin
  AncStr:=ColorStringGrid.Cells[ACol,ARow];
  Value:=Trim(Value);
  if (ACol mod 2)=0 then
    Value:=AncStr
  else if ACol=1 then
    begin
      if (Value<>'0') and (Value<>'1') then Value:=AncStr;
    end
  else
    begin
      try
        n:=StrToInt(Value);
        if n>=MaxiNum then Value:=AncStr;
      except
        Value:=AncStr;
      end;
    end
end;
function TAffTabCod.VerifieCode:Boolean;
Var
  StrVerif:string;
  i,j,n,mm:integer;
  CopieLigne:TStringList;
begin
  Result:=False;
  for j:=1 to ColorStringGrid.RowCount-1 do
    begin
      StrVerif:='';
      mm:=-1;
      for i:=0 to MaxiNum-1 do
        begin
          ColorStringGrid.Cells[i*2+2,j]:=Trim(ColorStringGrid.Cells[i*2+2,j]);
          ColorStringGrid.Cells[i*2+3,j]:=Trim(ColorStringGrid.Cells[i*2+3,j]);
          if ColorStringGrid.Cells[i*2+2,j]<>'' then
            begin
              StrVerif:=StrVerif+'F';
              mm:=i;
            end
          else
            break;
        end;
      for i:=0 to mm do
        begin
          try
            n:=StrToInt(ColorStringGrid.Cells[i*2+3,j]);
            if n>mm then
              begin
//                MessageDlg('numro de code trop lev pour l''tat '+ColorStringGrid.Cells[i*2+2,j] +' du caractre '+ColorStringGrid.Cells[0,j],mtError,[mbOK],0);
                MessageDlg(M_numrodecodetropleve+ColorStringGrid.Cells[i*2+2,j] +M_duCaractere+ColorStringGrid.Cells[0,j],mtError,[mbOK],0);
                exit;
              end;
            if StrVerif[n+1]='V' then
              begin
//                MessageDlg('numro de code en double pour l''tat '+ColorStringGrid.Cells[i*2+2,j] +' du caractre '+ColorStringGrid.Cells[0,j],mtError,[mbOK],0);
                MessageDlg(M_numrodecodeendouble +ColorStringGrid.Cells[i*2+2,j] +M_duCaractere+ColorStringGrid.Cells[0,j],mtError,[mbOK],0);
                exit;
              end
            else StrVerif[n+1]:='V';
          except
            begin
//              MessageDlg('numro de code illisible pour l''tat '+ColorStringGrid.Cells[i*2+2,j] +' du caractre '+ColorStringGrid.Cells[0,j],mtError,[mbOK],0);
              MessageDlg(M_numrodecodeillisib+ColorStringGrid.Cells[i*2+2,j] +M_duCaractere+ColorStringGrid.Cells[0,j],mtError,[mbOK],0);
              exit;
            end
          end;
        end;
      // remise en ordre des tats;
      CopieLigne:=TStringList.Create;
      For i:=0 to mm do
        begin
          CopieLigne.Add(trim(ColorStringGrid.Cells[i*2+2,j]));
          CopieLigne.Add(trim(ColorStringGrid.Cells[i*2+3,j]));
        end;
      For i:=0 to mm do
        begin
          n:=CopieLigne.IndexOf(IntToStr(i));
          if n>0 then
            begin
              ColorStringGrid.Cells[i*2+2,j]:=CopieLigne[n-1];
              ColorStringGrid.Cells[i*2+3,j]:=CopieLigne[n];
            end;
        end;
      CopieLigne.Free;
    end;
  Result:=True;
end;
procedure TAffTabCod.AnnuleCouleurClick(Sender: TObject);
Var
  i:integer;
begin
  for i:=0 to MaxiNum-1 do
    AffCouls[i]:=CoulRAZ;
  ColorStringGrid.RAZAffichCell;
  AInitialiser:=False;
  ConstruitTableau;
end;
function TAffTabCod.VerifieCouleurs:Boolean;
Var
  i,j,k,mm:integer;
begin
  Result:=False;
  for j:=1 to ColorStringGrid.RowCount-1 do
    begin
      mm:=-1;
      for i:=0 to MaxiNum-1 do
        if ColorStringGrid.Cells[i*2+2,j]<>'' then
          mm:=i
        else
          break;
      for i:=0 to mm-1 do
        begin
          // vrifier que tout ce qui est >0 est color
          if (i>0) and ((Not ColorStringGrid.AffichCell[i*2+2,j].Active) or (ColorStringGrid.AffichCell[i*2+2,j].CouleurFond=clWhite)) then
            begin
//              MessageDlg('La case de l''tat '+ColorStringGrid.Cells[i*2+2,j] +' du caractre '+ColorStringGrid.Cells[0,j]+' n''est pas colore',mtError,[mbOK],0);
              MessageDlg(M_LacasedeltatColorS+ColorStringGrid.Cells[i*2+2,j] +M_duCaractere+ColorStringGrid.Cells[0,j]+M_pascoloree,mtError,[mbOK],0);
              exit;
            end;
          // vrifier qu'il n'y a pas 2 fois la mme couleur
          for k:=i+1 to mm do
            begin
              if AfficCoulIdentiques(ColorStringGrid.AffichCell[i*2+2,j],ColorStringGrid.AffichCell[k*2+2,j]) then
                begin
//                  MessageDlg('Deux tat du caractre '+ColorStringGrid.Cells[0,j]+' ont la mme couleur',mtError,[mbOK],0);
                  MessageDlg(M_Deuxtatducaractre+ColorStringGrid.Cells[0,j]+M_ontlammecouleur,mtError,[mbOK],0);
                  exit;
                end;
            end;
        end;
    end;
  Result:=True;
end;
procedure TAffTabCod.ChargeLangue;
begin
  Caption:=C_AffTabCod;//Tableau de codage
  Label2.Caption:=C_AffTabCodLabel2;//Couleurs a utiliser pour les cases cliques
  CouleurTexte.Caption:=C_AffTabCodCouleurTexte;//couleur du texte
  Label3.Caption:=C_AffTabCodLabel3;//Style de remplissage
  StyleFond.Text:=C_AffTabCodStyleFond;//plein
  ModeColor.Text:=C_AffTabCodModeColor;//Colorer de la mme manire les tats de mme rang
  AnnuleCouleur.Hint:=H_AffTabCodAnnuleCouleur;//Annuler tous les codages
  AnnuleCouleur.Caption:=C_AffTabCodAnnuleCouleur;//Annuler
  Valider.Hint:=H_AffTabCodValider;//Vrifier et valider le codage
  Valider.Caption:=C_AffTabCodValider;//Valider
  commetexte1.Caption:=C_AffTabCodcommetexte1;//comme texte
  commeimage1.Caption:=C_AffTabCodcommeimage1;//comme image
  Editer1.Caption:=C_AffTabCodEditer1;//Editer
  Modifier1.Caption:=C_AffTabCodModifier1;//Modifier le codage
  Mettreencouleurs1.Caption:=C_AffTabCodMettreencouleurs1;//Mettre en couleurs
  Reveniraucodagedorigine1.Caption:=C_AffTabCodReveniraucodagedorigine1;//Revenir au codage d'origine
end;
end.
